// C Source File
// Created 15/10/2003; 19:53:34

#define USE_TI89              // Compile for TI-89
#define USE_TI92PLUS          // Compile for TI-92 Plus
#define USE_V200
#define OPTIMIZE_ROM_CALLS 		// Use ROM Call Optimization
#define RETURN_VALUE					// Return a value at the end of function main
#define MIN_AMS 101           // Compile for AMS 1.00 or higher

#include <tigcclib.h>

void _main()
{
	ESI argPtr;
	InitArgPtr(argPtr);
	if(ArgCount()!=2 || GetArgType(argPtr)!=STR_TAG)goto error;
	char nb[20];
	strcpy(nb, GetStrnArg(argPtr));
	if(GetArgType(argPtr)!=POSINT_TAG)goto error;
	int base=GetIntArg(argPtr);

	int len=-1;
	while(nb[++len]);
	int coef=0;
	long int nbFin=0;
	int puiss=0;
	for(--len; len>=0; len--){
		short nbVal=nb[len];
		switch(nbVal){
			case 48 ... 57: coef=48; break;
			case 65 ... 90: coef=55; break;
			case 97 ... 122: coef=87; break;
		}
		nbVal=nbVal-coef;
		if(nbVal>base-1){
			ST_showHelp("A digit is greater than base...");
			push_longint(-1);
			return;
		}
		nbFin+=(long int)nbVal*pow((float)base, (float)puiss);
		puiss++;
	}
	goto end;
	error:
		ST_showHelp("Usage : xx2dec(string number, int base");
		nbFin=-1;
	end:
	push_longint(nbFin);
	return;
}


